class Tag < ActiveRecord::Base
  has_many :assorts
  has_many :links, :through=>:assorts

  def self.find_by_user_name(user_name)
    Tag.find_by_sql([<<-SQL, {:user_name => user_name}])
      SELECT 
        count(tags.name) cnt
        ,tags.*
      FROM
        users,
        tags,
        assorts,
        links
      WHERE
        users.login = :user_name
      AND
        links.user_id = users.id
      AND
        assorts.link_id = links.id
      AND
        tags.id = assorts.tag_id
      GROUP BY tags.name
    SQL
  end

end
